/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.company.actions;

import org.blueoxygen.cimande.company.Company;

import com.opensymphony.xwork2.validator.annotations.RequiredStringValidator;
import com.opensymphony.xwork2.validator.annotations.Validation;
import com.opensymphony.xwork2.validator.annotations.Validations;

/**
 * @author Gurki
 */
@Validation
public class AddCompany extends CompanyForm {

	private Company company = new Company();

	@Validations(requiredStrings = { @RequiredStringValidator(fieldName = "name", message = "Name can't be empty") })
	public String execute() {
		company.setId(null);
		company.setName(getName());
		company.setAddress(getAddress());
		company.setState(getState());
		company.setZip_number(getZip_number());
		company.setTelephone(getTelephone());
		company.setFaximile(getFaximile());
		company.setWebsite(getWebsite());
		company.setEmail(getEmail());
		service.save(company);

		return SUCCESS;
	}

}