/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.jobdescription.actions;

import org.blueoxygen.cimande.jobdescription.JobDesc;
import com.opensymphony.xwork2.validator.annotations.RequiredStringValidator;
import com.opensymphony.xwork2.validator.annotations.Validation;
import com.opensymphony.xwork2.validator.annotations.Validations;

/*******************************
 * @author Praditya Eldorado
 * 		   aldo.donal@gmail.com
 *******************************/

@Validation
public class AddJobDesc extends JobDescForm {

	@Validations(requiredStrings = {
			@RequiredStringValidator(fieldName = "name", message = "Please input name"),
			@RequiredStringValidator(fieldName = "description", message = "Please input description") })
	public String execute() {

		JobDesc job = new JobDesc();

		if (hasErrors()) {
			return INPUT;

		} else {

			job.setName(getName());
			job.setDescription(getDescription());
			job.getLogInformation().setActiveFlag(getActiveFlag());
			service.save(job);
			return SUCCESS;
		}

	}

}