package org.blueoxygen.cimande.persistence;

import java.io.Serializable;
import java.util.List;

public interface GenericPersistenceManager {

	long getRowCount(Class clazz);

	void save(Object objectToSave);

	void persist(Serializable ovbjectToSave);

	void merge(Serializable objectToSave);

	void remove(Object objectToRemove);

	<T> T getById(Class<T> type, long id);

	<T> T getByUniqueField(Class<T> type, Object pk, String fieldName);

	<T> List<T> findAll(Class<T> type);

	<T> List<T> findAllSorted(Class<T> type, String sortProperty);

	<T> List<T> findAllSortedDirected(Class<T> type, String sortField,
			String direction);

	List find(String query, Object[] parameters, Class[] parameter_types);

	List getList(String query, Object[] parameters, Class[] parameter_types);

	<T> T getById(Class<T> aClass, String id);
}
