/**
 * CimandeActionProxyFactory.java
 *
 * Created on 5 Sep 2010 04:40:45
 */
package org.blueoxygen.cimande.rest;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;

import com.opensymphony.xwork2.ActionInvocation;
import com.opensymphony.xwork2.ActionProxy;
import com.opensymphony.xwork2.DefaultActionProxyFactory;
import com.opensymphony.xwork2.util.logging.Logger;
import com.opensymphony.xwork2.util.logging.LoggerFactory;

/**
 * @author Dian Aditya
 * 
 */
public class CimandeRestActionProxyFactory extends DefaultActionProxyFactory {

	private Logger LOG = LoggerFactory
			.getLogger(CimandeRestActionProxyFactory.class);

	public ActionProxy createActionProxy(String namespace, String actionName,
			String methodName, Map<String, Object> extraContext,
			boolean executeResult, boolean cleanupContext) {

		ActionInvocation invocation = new CimandeRestActionInvocation(
				extraContext, true);
		container.inject(invocation);

		ActionProxy actionProxy = createActionProxy(invocation, namespace,
				actionName, executeResult, cleanupContext);

		HttpServletRequest request = (HttpServletRequest) extraContext
				.get("com.opensymphony.xwork2.dispatcher.HttpServletRequest");

		String httpMethod = request.getMethod().toLowerCase();
		httpMethod = httpMethod.substring(0, 1).toUpperCase()
				+ httpMethod.substring(1);

		methodName = actionProxy.getMethod() + httpMethod;

		Object action = actionProxy.getAction();

		// Handle some issues with AnnotationValidationInterceptor
		try {
			action.getClass().getMethod(methodName, new Class[0]);
		} catch (SecurityException e) {
			e.printStackTrace();
		} catch (NoSuchMethodException e) {
			methodName = actionProxy.getMethod();
			LOG.debug("Method " + methodName + " not found. Point to "
					+ actionProxy.getMethod());
		}

		return createActionProxy(invocation, namespace, actionName, methodName,
				executeResult, cleanupContext);
	}

}
