/**
 * CimandeActionMapper.java
 *
 * Created on 05 Agu 2010 15:31:12
 */
package org.blueoxygen.cimande.rest.mapper;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts2.StrutsConstants;
import org.apache.struts2.dispatcher.mapper.ActionMapping;
import org.apache.struts2.dispatcher.mapper.DefaultActionMapper;
import org.blueoxygen.cimande.rest.manager.ContentHandlerManager;

import com.opensymphony.xwork2.config.ConfigurationManager;
import com.opensymphony.xwork2.inject.Inject;

/**
 * @author Dian Aditya
 * 
 */
public class CimandeRestActionMapper extends DefaultActionMapper {
	public static final String HTTP_METHOD_PARAM = "_method";
	private String idParameterPrefix = "_";
	private String idParameterName = "id";
	private ContentHandlerManager manager;
	private String extensionPrefix = "cimande";

	@Inject(required = false, value = "cimande.rest.extension.prefix")
	public void setExtensionPrefix(String prefix) {
		this.extensionPrefix = prefix;
	}

	@Inject(required = false, value = StrutsConstants.STRUTS_ID_PARAMETER_NAME)
	public void setIdParameterName(String idParameterName) {
		this.idParameterName = idParameterName;
	}

	@Inject
	public void setHandler(ContentHandlerManager manager) {
		this.manager = manager;
	}

	@Inject(required = false, value = "cimande.rest.idParameterPrefix")
	public void setIdParameterPrefix(String prefix) {
		this.idParameterPrefix = prefix;
	}

	public ActionMapping getMapping(HttpServletRequest request,
			ConfigurationManager configManager) {
		ActionMapping mapping = super.getMapping(request, configManager);
		List<String> params = new ArrayList<String>();

		if (mapping == null)
			return mapping;

		if (mapping.getParams() == null)
			mapping.setParams(new HashMap<String, Object>());

		if (mapping.getName().endsWith("/")) {
			mapping.setName(mapping.getName().substring(0,
					mapping.getName().lastIndexOf('/')));
		}

		for (String extension : manager.getHandlerByExtension().keySet()) {
			if (mapping.getName().endsWith("/" + extension)) {
				mapping.setName(mapping.getName().substring(0,
						mapping.getName().lastIndexOf("/" + extension)));
				break;
			}
		}

		return mapping;
	}
}
