package org.blueoxygen.cimande.role.actions.servicewfrole;

import org.blueoxygen.cimande.persistence.hibernate.dao.HibernatePersistenceDaoManager;
import org.blueoxygen.cimande.role.UserRole;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

@Repository
@Transactional(readOnly = true)
public class ServiceUserRoleImpl extends
		HibernatePersistenceDaoManager<UserRole> implements ServiceUserRole {
	@Transactional
	public void save(UserRole ur) {
		if (ur != null) {
			if (ur.getId() == null || "".equalsIgnoreCase(ur.getId())) {
				ur.getLogInformation().setCreateBy(getCurrentUser().getId());
				ur.getLogInformation()
						.setLastUpdateBy(getCurrentUser().getId());
				ur.getLogInformation().setCreateDate(getCurretTime());
				ur.getLogInformation().setLastUpdateDate(getCurretTime());
				ur.getLogInformation().setActiveFlag(1);
				persist(ur);
			} else {
				ur.getLogInformation()
						.setLastUpdateBy(getCurrentUser().getId());
				ur.getLogInformation().setLastUpdateDate(getCurretTime());

				merge(ur);
			}

		}

	}

	@Transactional
	public void delete(UserRole ur) {
		if (ur != null && ur.getId() != null) {
			ur = getById(UserRole.class, ur.getId());

			remove(ur);
		}
	}

	@Transactional(readOnly = true)
	public UserRole getUserRoleById(String id) {
		return getById(UserRole.class, id);
	}

	public UserRole getUserRoleBy(String idUser, String idRole) {
		return getByUniqueField(UserRole.class,idUser, "user.id");
	}
}
