/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.roleprivilage.actions;

import org.blueoxygen.cimande.role.RolePrivilage;

import com.opensymphony.xwork2.validator.annotations.RequiredStringValidator;
import com.opensymphony.xwork2.validator.annotations.Validation;
import com.opensymphony.xwork2.validator.annotations.Validations;


/**
 * @author Miftachur Rohman
 *
 */
@Validation
public class AddRolePrivilage extends RolePrivilageForm {

	private RolePrivilage rolePrivilage = new RolePrivilage();

	@Validations(requiredStrings = { @RequiredStringValidator(fieldName = "name", message = "Name can't be empty") })
	public String execute() {
		rolePrivilage.setRole(role);
		rolePrivilage.setModuleFunction(moduleFunction);
		rolePrivilage.setPrivilage_flag(privilage_flag);
		rolePrivilage.setUrl_xml(url_xml);
		service.save(rolePrivilage);

		return SUCCESS;
	}

}
