/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.roleprivilage.actions;

import java.util.ArrayList;
import java.util.List;


/**
 * @author Miftachur Rohman
 *
 */
public class SearchRolePrivilage extends RolePrivilageForm {

	private List rolePrivilages = new ArrayList();
	private int maxPage, currPage, nextPage, prevPage = 0, page = 0;
	private int maxRowPerPage = 10;
	private String orderBy = "name";
	private int resultRows;

	public String execute() {
		resultRows = service.getRowCountByCriteria(getRole(),
				getModuleFunction(), getUrl_xml(), getPrivilage_flag());

		maxPage = resultRows / maxRowPerPage;
		if (resultRows % maxRowPerPage == 0)
			maxPage = maxPage - 1;
		rolePrivilages = service.findRolePrivilages(getRole(),
				getModuleFunction(), getUrl_xml(), getPrivilage_flag(),
				getOrderBy(), getMaxRowPerPage(), currPage * maxRowPerPage);

		prevPage = currPage - 1;
		nextPage = currPage + 1;
		page = currPage + 1;

		model.put("rolePrivilagelist", rolePrivilages);

		return SUCCESS;
	}

	public int getCurrPage() {
		return currPage;
	}

	public void setCurrPage(int currPage) {
		this.currPage = currPage;
	}

	public int getMaxPage() {
		return maxPage;
	}

	public void setMaxPage(int maxPage) {
		this.maxPage = maxPage;
	}

	public int getMaxRowPerPage() {
		return maxRowPerPage;
	}

	public void setMaxRowPerPage(int maxRowPerPage) {
		this.maxRowPerPage = maxRowPerPage;
	}

	public int getNextPage() {
		return nextPage;
	}

	public void setNextPage(int nextPage) {
		this.nextPage = nextPage;
	}

	public String getOrderBy() {
		return orderBy;
	}

	public void setOrderBy(String orderBy) {
		this.orderBy = orderBy;
	}

	public int getPrevPage() {
		return prevPage;
	}

	public void setPrevPage(int prevPage) {
		this.prevPage = prevPage;
	}

	public List getrolePrivilages() {
		return rolePrivilages;
	}

	public void setrolePrivilages(List rolePrivilages) {
		this.rolePrivilages = rolePrivilages;
	}

	public int getResultRows() {
		return resultRows;
	}

	public void setResultRows(int resultRows) {
		this.resultRows = resultRows;
	}

	// public Session getSess() {
	// return sess;
	// }

	// public void setSess(Session sess) {
	// this.sess = sess;
	// }

}