/*******************************************************************************
 * Copyright (c) 2005 BlueOxygen Technology.
 *******************************************************************************/
package org.blueoxygen.cimande.roleprivilage.actions;

import java.sql.Timestamp;

import org.blueoxygen.cimande.modulefunction.ModuleFunction;
import org.blueoxygen.cimande.role.Role;
import org.blueoxygen.cimande.role.RolePrivilage;

import com.opensymphony.xwork2.validator.annotations.RequiredStringValidator;
import com.opensymphony.xwork2.validator.annotations.Validation;
import com.opensymphony.xwork2.validator.annotations.Validations;


/**
 * @author Miftachur Rohman
 *
 */
@Validation
public class UpdateRolePrivilage extends RolePrivilageForm {

	private String id;
	private RolePrivilage rolePrivilage;

	@Validations(requiredStrings = {
			@RequiredStringValidator(fieldName = "name", message = "Name can't be empty."),
			@RequiredStringValidator(fieldName = "description", message = "Description can't be empty.") })
	public String execute() {
		
		rolePrivilage = service.getRolePrivilageById(getId());
		
		rolePrivilage.setPrivilage_flag(getPrivilage_flag());
		rolePrivilage.setUrl_xml(getUrl_xml());
		rolePrivilage.setRole(role);
		rolePrivilage.setModuleFunction(moduleFunction);

		if (getRole_id().equalsIgnoreCase(""))
			addActionError("Role ID can't be empty.");

		if (hasErrors()) {
			return INPUT;
		} else {
			logInfo = rolePrivilage.getLogInformation();
			logInfo.setLastUpdateBy(getCurrentUser().getId());
			logInfo.setLastUpdateDate(new Timestamp(System.currentTimeMillis()));
			rolePrivilage.setLogInformation(logInfo);

			service.save(rolePrivilage);

			return SUCCESS;
		}
	}

	/**
	 * @return Returns the id.
	 */
	public String getId() {
		return id;
	}

	/**
	 * @param id
	 *            The id to set.
	 */
	public void setId(String id) {
		this.id = id;
	}

}
