package org.blueoxygen.cimande.rolesiteprivilage.service;

import java.util.List;

import org.blueoxygen.cimande.persistence.hibernate.dao.HibernatePersistenceDaoManager;
import org.blueoxygen.cimande.role.RoleSitePrivilage;
import org.hibernate.Criteria;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

@Repository
@Transactional(readOnly = true)
public class RoleSitePrivilageServiceImpl extends
		HibernatePersistenceDaoManager<RoleSitePrivilage> implements
		RoleSitePrivilageService {
	@Transactional(readOnly = true)
	public List<RoleSitePrivilage> getList(String roleSiteId, int activeFlag) {
		Criteria criteria = sessionFactory.getCurrentSession().createCriteria(
				RoleSitePrivilage.class);
		criteria.add(Restrictions.like("roleSite.id", roleSiteId));
		criteria.add(Restrictions.like("logInformation.activeFlag", activeFlag));
		return criteria.list();
	}

}
