/*******************************************************************************
 * Copyright (c) 2004 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Team - initial API and implementation
 *******************************************************************************/

package org.blueoxygen.cimande.site.actions;

import org.blueoxygen.cimande.site.Site;
import com.opensymphony.xwork2.validator.annotations.RequiredStringValidator;
import com.opensymphony.xwork2.validator.annotations.Validation;
import com.opensymphony.xwork2.validator.annotations.Validations;

/*****************************************************************************
 * @author Praditya Eldorado aldo.donal@gmail.com
 * 
 *         TODO To change the template for this generated type comment go to
 *         Window - Preferences - Java - Code Style - Code Templates
 *****************************************************************************/

@Validation
public class AddSite extends SiteForm {
	private Site site = new Site();
	private Site st = new Site();

	@Validations(requiredStrings = {
			@RequiredStringValidator(fieldName = "name", message = "Name can't be empty."),
			@RequiredStringValidator(fieldName = "description", message = "Description can't be empty."),
			@RequiredStringValidator(fieldName = "workspace_type", message = "Workspace Type can't be empty.") })
	public String execute() {
		if (hasErrors()) {
			return INPUT;

		} else {
			site.setName(getName());
			site.setDescription(getDescription());
			site.setTitle(getTitle());
			site.setUrl_branding(getUrl_branding());
			site.setSite_url(getSite_url());
			site.setAdmin_email(getAdmin_email());
			site.setNotify_flag(getNotify_flag());
			site.setNotify_from(getNotify_from());
			site.setNotify_message(getNotify_message());
			site.setNotify_email(getNotify_email());
			site.setSecret_key(getGenerateKey());
			site.setWorkspace_type(getWorkspace_type());
			if (getParentId() != null && !"".equalsIgnoreCase(getParentId())) {
				st = service.getSiteById(getParentId());
			} else {
				st = null;
			}

			site.setParentId(st);
			service.save(site);
			return SUCCESS;
		}
	}
}