/*******************************************************************************
 * Copyright (c) 2005 BlueOxygen Technology.
 *******************************************************************************/
package org.blueoxygen.cimande.site.actions;

import org.blueoxygen.cimande.site.Site;
import com.opensymphony.xwork2.validator.annotations.RequiredStringValidator;
import com.opensymphony.xwork2.validator.annotations.Validation;
import com.opensymphony.xwork2.validator.annotations.Validations;

/*******************************
 * @author Praditya Eldorado 
 *         aldo.donal@gmail.com
 *******************************/

@Validation
public class UpdateSite extends SiteForm {

	private Site site;

	@Validations(requiredStrings = {
			@RequiredStringValidator(fieldName = "name", message = "Name can't be empty."),
			@RequiredStringValidator(fieldName = "description", message = "Description can't be empty.") })
	public String execute() {
		site = service.getSiteById(getId());
		site.setName(getName());
		site.setDescription(getDescription());
		site.setTitle(getTitle());
		site.setAdmin_email(getAdmin_email());
		site.setNotify_email(getNotify_email());
		site.setNotify_flag(getNotify_flag());
		site.setNotify_from(getNotify_from());
		site.getLogInformation().setActiveFlag(getActiveFlag());
		site.setNotify_message(getNotify_message());
		site.setUrl_branding(getUrl_branding());
		site.setSecret_key(getGenerateKey());
		if (getIdSite() != null && !"".equalsIgnoreCase(getParentId())) {
			setIdSite(service.getSiteById(getParentId()));
		} else {
			setIdSite(null);
		}
		site.setParentId(getIdSite());

		if (getWorkspace_type().equalsIgnoreCase("")) {
			site.setWorkspace_type(get("workspace.type.default.role"));
		} else {
			site.setWorkspace_type(getWorkspace_type());
		}
		site.setSite_url(getSite_headline());
		site.setSite_url(getSite_url());
		service.save(site);
		return SUCCESS;

	}
}
