/*******************************************************************************
 * Copyright (c) 2011 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Cimande Team - initial API and implementation
 *******************************************************************************/
package org.blueoxygen.cimande.social.service;

import java.util.Set;

import org.blueoxygen.cimande.role.Role;
import org.blueoxygen.cimande.security.User;
import org.blueoxygen.cimande.site.Site;
import org.blueoxygen.cimande.social.SocialAccount;

/**
 * @author Dian Aditya
 * 
 */
public interface SocialAccountService {
	User getUserBySocialAccount(String provider, String username);

	Set<SocialAccount> getSocialAccountByUser(String userId);

	User getUserByEmail(String email);

	User addNewUserBySocialAccount(SocialAccount socialAccount);

	Role getDefaultRole();

	Site getDefaultSite();

}
