/*******************************************************************************
 * Copyright (c) 2011 BlueOxygen Technology.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the BlueOxygen Software License v1.0
 * which accompanies this distribution, and is available at
 *
 * Contributors:
 *     BlueOxygen Cimande Team - initial API and implementation
 *******************************************************************************/
package org.blueoxygen.debus.interceptors;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.struts2.ServletActionContext;
import org.blueoxygen.cimande.rest.manager.ContentHandlerManager;
import org.blueoxygen.cimande.security.login.interceptors.LoginInterceptor;
import org.blueoxygen.cimande.sitemanager.yuitree.treenode.TreeNodeFactory;
import org.springframework.beans.factory.annotation.Autowired;

import com.opensymphony.xwork2.ActionInvocation;
import com.opensymphony.xwork2.inject.Container;
import com.opensymphony.xwork2.inject.Inject;

/**
 * @author Dian Aditya
 * 
 */
public class PageAccessInterceptor extends LoginInterceptor {

	private ContentHandlerManager handlerManager;

	@Autowired
	private TreeNodeFactory nodeFactory;

	@Inject
	public void setContainer(Container container) {
		handlerManager = container.getInstance(ContentHandlerManager.class);
	}

	public void destroy() {
	}

	public void init() {
	}

	@SuppressWarnings("unchecked")
	public String intercept(ActionInvocation invocation) throws Exception {
		HttpServletRequest request = ServletActionContext.getRequest();
		HttpSession session = request.getSession(true);
		String servletPath = request.getServletPath();
		String extension = servletPath.substring(
				servletPath.lastIndexOf('.') + 1).toLowerCase();

		String descriptor = null;
		boolean intercept = false;

		for (String url : filterUrls) {
			if (request.getServletPath().startsWith(url)) {
				intercept = true;
				descriptor = servletPath.replaceFirst(url, "");

				break;
			}
		}

		if (!intercept) {
			return invocation.invokeActionOnly();
		}

		for (String sExtension : handlerManager.getHandlerByExtension()
				.keySet()) {
			if (descriptor.endsWith(sExtension)) {
				descriptor = descriptor.substring(0,
						descriptor.lastIndexOf("/"));

				break;
			}
		}

		if (!nodeFactory.hasAccess(descriptor.substring(1,
				descriptor.lastIndexOf("/")))) {

			ServletActionContext.getResponse().getWriter().write("Forbidden");

			return null;
		}

		return invocation.invoke();
	}

}
