package org.blueoxygen.debus.interceptors;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JOptionPane;

import org.blueoxygen.cimande.persistence.GenericPersistenceManager;
import org.blueoxygen.cimande.persistence.PersistenceManager;
import org.blueoxygen.cimande.security.SessionCredentials;
import org.blueoxygen.cimande.security.User;
import org.blueoxygen.debus.entity.RoleDescriptorACLAccess;
import org.springframework.beans.factory.annotation.Autowired;

import com.opensymphony.xwork2.ActionInvocation;
import com.opensymphony.xwork2.interceptor.Interceptor;

public class RoleDescriptorACLInterceptor implements Interceptor {

	@Autowired
	private GenericPersistenceManager manager;
	@Autowired
	private SessionCredentials sessionCredential;

	public void destroy() {
	}

	public void init() {
	}

	@SuppressWarnings("unchecked")
	public String intercept(ActionInvocation actionInvocation) throws Exception {
		String namespace = actionInvocation.getProxy().getNamespace();
		String actionName = actionInvocation.getProxy().getActionName();
		String descriptorCandidate[] = namespace.split("/");
		if (descriptorCandidate.length != 0) {
			if ("module".equalsIgnoreCase(descriptorCandidate[1])) {
				String descriptorName = descriptorCandidate[2];
				List<RoleDescriptorACLAccess> rdAccesses = new ArrayList<RoleDescriptorACLAccess>();
				rdAccesses = manager.getList("SELECT rda FROM "
						+ RoleDescriptorACLAccess.class.getName()
						+ " rda WHERE rda.roleDescriptor.role.id='"
						+ getCurrentUser().getRole().getId()
						+ "' AND rda.roleDescriptor.descriptor.name='"
						+ descriptorName + "'", null, null);
				if (!rdAccesses.isEmpty()) {
					for (RoleDescriptorACLAccess rda : rdAccesses) {
						if (actionName
								.equalsIgnoreCase(rda.getAcl().getValue())) {
							return actionInvocation.invoke();
						}
					}
					return "notallowed";
				}
			}
		}

		return actionInvocation.invoke();
	}

	private User getCurrentUser() {
		return sessionCredential.getCurrentUser();
	}

}
